100 REMark Dunric's 8K Adventure - Converted from the Commodore 64 on June 23, 2004
110 REMark Author: Paul Panks (dunric@gmail.com)
120 REMark Revision: 1.08q
130 REMark Homepage: http://www.geocities.com/dunric/8kadv.html
140 REMark Ported to QL SuperBASIC by Dilwyn Jones 2023
150 :
160 loadsave$ = 'win1_8KADV_' : REMark drive/directory where game state saved
170 :
180 WINDOW #1,484,12,14,12 : PAPER #1,0 : INK #1,4 : BORDER #1,1,2 : CSIZE #1,2,0
190 WINDOW #0,484,232,14,24 : PAPER #0,0 : INK #0,7 : BORDER #0,1,2 : CSIZE #0,2,0
200 CLS : PRINT TO 9;"DUNRIC'S 8K ADVENTURE"
210 CLS #0 : PRINT #0,"Welcome!" : PRINT #0,
220 DIM no$(20,28),ob$(20,28),vb$(20,10),de$(25,2,40),m(25,6),lo(20),wd$(2,20)
230 RESTORE
240 FOR x = 1 TO 25 : READ de$(x,1) : READ de$(x,2) : REMark descriptions
250 FOR x = 1 TO 20 : READ vb$(x)                   : REMark verb
260 FOR x = 7 TO 20 : READ no$(x)                   : REMark nouns
270 FOR x = 7 TO 20 : READ ob$(x)                   : REMark objects
280 FOR x = 1 TO 25
290   FOR y = 1 TO 6 : READ m(x,y)                  : REMark map
300 END FOR x
310 FOR x = 1 TO 20 : READ lo(x)                    : REMark locations
320 no$(1) = "north" : no$(2) = "south" : no$(3) = "east"
330 no$(4) = "west"  : no$(5) = "up"    : no$(6) = "down"
340 rm = 1: ic = 0: lz = 0: hp = 200 : dm = 1
350 :
360 INPUT #0,"Load a saved game (y/n):";f$
370 IF f$ == "y" THEN PRINT #0, : GO TO 420
380 IF f$ == "n" THEN PRINT #0, : GO TO 530
390 GO TO 360
400 :
410 REMark --- load a saved game ---
420 INPUT #0,"Enter name of saved file:";f$
430 IF LEN(f$) > 41 THEN PRINT #0, : PRINT #0,"Filename too long!" : GO TO 360
440 IF f$ = '' THEN GO TO 530
450 OPEN_IN #3,loadsave$ & f$ & '_dat'
460 INPUT #3,na$ : INPUT #3,rm : INPUT #3,lz : INPUT #3,lk : INPUT #3,hp : INPUT #3,ic
470 FOR x = 7 TO 20 : INPUT #3,lo(x)
480 CLOSE #3
490 PRINT #0,"Done!" : PRINT #0,
500 GO TO 570
510 :
520 REMark --- get player name (used for saving/loading game status ---
530 INPUT #0,"Enter your name:";na$
540 IF LEN(na$) > 8 THEN PRINT #0, : PRINT #0,"Name too long!" : GO TO 530
550 :
560 REMark --- describe location ---
570 PAUSE 50 : CLS #0
580 PRINT #0,de$(rm,1) : PRINT #0,de$(rm,2) : PRINT #0,"Exits:";
590 FOR x = 1 TO 6
600   IF m(rm,x) > 0 THEN PRINT #0,"  ";no$(x);
610 END FOR x
620 PRINT #0,
630 FOR x = 7 TO 20
640   IF lo(x) = rm THEN PRINT #0,no$(x)
650 END FOR x
660 :
670 REMark --- enter a command ---
680 INPUT #0,"> ";a$ : PRINT #0,
690 IF lo(16) = -1 THEN
700   REMark game over
710   PRINT #0,\"Congratulations! You found the scepter!"
720   PRINT #0,"You have completed the adventure."
730   PAUSE 50 : STOP
740 END IF
750 wd$(1) = "" : wd$(2) = "" : si = 0 : yi = 0
760 IF LEN(a$) = 1 THEN GO TO 1180 : REMark one letter command
770 :
780 REMark --- search for space dividing words ---
790 FOR x = 1 TO LEN(a$)
800   IF Mid$(a$,x,1) = " " THEN wd$(1) = Left$(a$,x-1) : si = x + 1 : yi = 1
810 END FOR x
820 GO SUB 2250
830 IF yi = 1 THEN wd$(2) = Mid$(a$,si,x)
840 IF LEN(wd$(1)) > 20 THEN PRINT #0,"Command too complex" : GO TO 680
850 :
860 REMark --- handle help request ---
870 IF a$ == "help" OR a$ = '?' THEN
880   INK #0,4 : PRINT #0,"Example:"; : INK #0,7 : PRINT #0," 'use lantern'"
890   INK #0,4 : PRINT #0,\"Verbs:"; : INK #0,7
900   PRINT #0,"go, get, drop, inventory, use,"
910   PRINT #0,"open, examine, climb, kill, north,"
920   PRINT #0,"south, east, west, up, down, quit, eat,"
930   PRINT #0,"drink, look, save."
940   GO TO 680
950 END IF
960 :
970 IF a$ == "quit" THEN CLS #0 : PRINT #0,"The end" : STOP : REMark end the game
980 :
990 REMark --- identify verb and noun ---
1000 v = 0
1010 FOR x = 1 TO 20 : IF vb$(x) == wd$(1) THEN v = x : EXIT x
1020 IF v = 0 THEN
1030   PRINT #0,"Verb not recognized." : PRINT #0,"Type ";
1040   PRINT #0,'"help" for clues' : GO TO 680
1050 END IF
1060 n = 0
1070 FOR x = 1 TO 20
1080   IF no$(x) == wd$(2) THEN n = x
1090 END FOR x
1100 IF n = 0 AND v <> 4 AND v <> 7 AND v <> 8 AND v > 9 AND v < 17 THEN PRINT #0,"Can't do that" : GO TO 680
1110 :
1120 REMark --- call appropriate routine for verb entered ---
1130 ON v GO TO 1300, 1380, 1470, 1630, 1510, 1740, 1750, 1860, 1910, 1300, 1300, 1300, 1300, 1300, 1300, 2130, 2070, 2090, 2110, 2160
1140 PRINT #0,"Can't do that" : REMark oops
1150 GO TO 680
1160 :
1170 REMark --- single letter commands ---
1180 IF a$ == "n" THEN n = 1 : GO TO 1300 : REMark north
1190 IF a$ == "s" THEN n = 2 : GO TO 1300 : REMark south
1200 IF a$ == "e" THEN n = 3 : GO TO 1300 : REMark east
1210 IF a$ == "w" THEN n = 4 : GO TO 1300 : REMark west
1220 IF a$ == "u" THEN n = 5 : GO TO 1300 : REMark up
1230 IF a$ == "d" THEN n = 6 : GO TO 1300 : REMark down
1240 IF a$ == "i" THEN v = 4 : GO TO 1630 : REMark inventory
1250 IF a$ == "l" THEN v = 19: GO TO 580  : REMark lantern
1260 IF a$ = "?" THEN GO TO 860  : REMark ?=help
1270 PRINT #0,"What?" : REMark oops
1280 GO TO 680
1290 :
1300 IF m(rm,n) = 0 THEN PRINT #0,"Can't go that way" : GO TO 680
1310 IF rm = 24 AND n = 1 AND lk = 0 THEN PRINT #0,"Cell door is locked" : PRINT #0,"I need a key!" : GO TO 680
1320 IF rm = 7 AND n = 2 AND lz = 0 THEN PRINT #0,"Too dark to move there" : PRINT #0,"I need the lantern turned on!" : GO TO 680
1330 IF lo(18) = rm THEN IF n = 2 THEN PRINT #0,"The goblin won't let you pass!" : GO TO 680
1340 IF lo(19) = rm THEN IF n = 1 THEN PRINT #0,"The knight bars passage north!" : GO TO 680
1350 IF lo(20) = rm THEN IF n = 1 THEN PRINT #0,"The demon hisses 'no scepter!'" : GO TO 680
1360 rm = m(rm,n) : GO TO 580
1370 :
1380 IF lo(n) = rm AND n > 6 AND n < 17 AND ic < 7 THEN
1390   ic = ic + 1 : lo(n) = -1 : PRINT #0,"Taken" : GO TO 680
1400 END IF
1410 :
1420 REMark carrying too many items?
1430 IF ic > 6 THEN PRINT #0,"Too heavy" : PRINT #0,"Drop some items!" : GO TO 680
1440 :
1450 PRINT #0,"Can't pick that up" : GO TO 680
1460 :
1470 IF lo(n) = -1 AND n > 6 AND n < 17 THEN ic = ic - 1 : lo(n) = rm : PRINT #0,"Dropped" : GO TO 680
1480 :
1490 PRINT #0,"Can't drop that" : GO TO 680
1500 :
1510 IF n = 7 AND lo(n) = -1 AND lz = 0 THEN IF lo(8) = -1 THEN PRINT #0,"Lantern flickers on" : lz = 1 : GO TO 680
1520 IF n = 7 AND lo(n) = -1 THEN PRINT #0,"Can't do that" : GO TO 680
1530 IF n = 9 AND lo(n) = -1 THEN
1540   IF rm = 9 THEN
1550     PRINT #0,"The rope catches on a branch" : PAUSE 50 : PRINT #0,"You climb up..."
1560     rm = 8 : lo(9) = 9 : ob$(9) = "rope (hanging down)" : ic = ic - 1 : GO TO 580
1570   END IF
1580 END IF
1590 IF n = 10 AND lo(n) = -1 AND lk = 0 THEN IF rm = 24 THEN lk = 1 : PRINT #0,"Click! cell door unlocks" : GO TO 680
1600 PRINT #0,"Can't do that"
1610 GO TO 680
1620 :
1630 REMark --- inventory ---
1640 INK #0,4
1650 IF lo(9) = -1 THEN ob$(9) = "coiled rope about 10 feet"
1660 ic = 0
1670 FOR x = 7 TO 16
1680   IF lo(x) = -1 THEN PRINT #0,"  ";no$(x) : ic = ic + 1
1690 END FOR x
1700 IF ic = 0 THEN PRINT #0,"You are empty handed"
1710 INK #0,7
1720 GO TO 680
1730 :
1740 PRINT #0,"Can't do that" : PRINT #0,"Try "; : PRINT #0,'"use"'; : PRINT #0," instead" : GO TO 680
1750 IF n = 0 THEN GO TO 1780
1760 PRINT #0,ob$(n) : GO TO 680
1770 :
1780 IF wd$(2) == "fireplace" AND rm = 4 THEN PRINT #0,"The fireplace is currently lit" : GO TO 680
1790 IF wd$(2) == "table" THEN IF rm = 8 THEN PRINT #0,"The table has words inscribed" : PRINT #0,"words read: '"; : PRINT #0,"use key to unlock cell"; : PRINT #0,"'" : GO TO 680
1800 IF wd$(2) == "bookshelf" THEN IF rm = 8 THEN PRINT #0,"The bookshelf contains many old books" : GO TO 680
1810 IF wd$(2) == "dresser" AND rm = 3 THEN PRINT #0,"It's an ordinary dresser" : GO TO 680
1820 IF wd$(2) == "bed" THEN IF rm = 11 OR rm = 3 THEN PRINT #0,"The bed looks comfortable" : GO TO 680
1830 IF wd$(2) == "tree" THEN IF rm = 9 THEN PRINT #0,"The tree has low branches" : GO TO 680
1840 IF wd$(2) == "throne" THEN IF rm = 22 THEN PRINT #0,"The throne is missing a scepter" : GO TO 680
1850 PRINT #0,"You notice nothing unusual" : GO TO 680
1860 IF wd$(2) == "tree" THEN IF rm <> 9 THEN PRINT #0,"You don't see a tree low enough to climb" : GO TO 680
1870 IF wd$(2) == "tree" THEN IF lo(9) <> -1 THEN PRINT #0,"You need the rope first" : GO TO 680
1880 IF wd$(2) == "tree" THEN PRINT #0,"You climb up..." : ob$(9) = "rope (hanging down)" : ic = ic - 1 : lo(9) = 9 : PAUSE 50 : rm = 8 : GO TO 580
1890 PRINT #0,"Can't climb that" : GO TO 680
1900 :
1910 REMark --- fight ---
1920 RANDOMISE : mh = INT(RND*n + 100) + 1 : IF n < 17 THEN PRINT #0,"You can't kill that" : GO TO 680
1930 RANDOMISE : i = INT(RND*15) + 1 : dm = 1 : IF lo(11) = -1 THEN dm = 8 : PRINT #0,"Use dagger" : GO TO 1950
1940 PRINT #0,"Bare hands"
1950 PRINT #0,">" : IF i <= 5 THEN PRINT #0,"You missed ";no$(n)
1960 IF i >= 6 AND i <= 10 THEN PRINT #0,"You hit ";no$(n) : mh = mh - 2*dm
1970 IF i >= 11 AND i <= 16 THEN PRINT #0,"You hit ";no$(n);" very hard!" : mh = mh - 5*dm
1980 PRINT #0,"Your hp"; : PRINT #0,":"; hp : PRINT #0,"the "; no$(n); : PRINT #0,":"; mh
1990 PRINT #0,"> " : INPUT #0,"Press ENTER to continue...",a$ : ac = 0 : IF i = 12 OR i = 13 THEN IF lo(12) = -1 THEN ac = i : hp = hp + i
2000 RANDOMISE : i = INT(RND*15) + 1 : IF i <= 5 THEN PRINT #0,"the ";no$(n);" missed you"
2010 IF i >= 6 AND i <= 10 THEN PRINT #0,"The ";no$(n);" hit you" : hp = hp - 2*i
2020 IF i >= 11 AND i <= 16 AND lo(13) <> -1 THEN PRINT #0,"The ";no$(n);" hit you very hard" : hp = hp - 3*i
2030 PRINT #0,"> " : IF mh < 1 OR mh < 0 THEN PRINT #0,"The ";no$(n);" has died" : lo(n) = 998 : PRINT #0,"You killed ";no$(n) : PAUSE 50 : hp = hp + 25 : GO TO 680
2040 IF hp < 1 OR hp < 0 THEN PRINT #0,"Alas, you have died" : PAUSE 50 : PRINT #0,"Better luck next time..." : STOP
2050 GO TO 1930
2060 :
2070 IF n = 14 AND lo(n) = -1 THEN PRINT #0,"You eat some food" : PAUSE 50 : PRINT #0,"You feel better!" : hp = hp + 10 : GO TO 680
2080 PRINT #0,"Can't eat that" : GO TO 680
2090 IF n = 15 AND lo(n) = -1 THEN PRINT #0,"You drink the water" : PAUSE 50 : PRINT #0,"You feel refreshed" : hp = hp + 25 : lo(n) = 5 : ic = ic - 1 : GO TO 680
2100 PRINT #0,"Can't drink that here" : GO TO 680
2110 GO TO 580
2120 :
2130 CLS #0 : PRINT #0,"Thanks for playing!" : STOP
2140 :
2150 REMark --- save game status, using player name for filename ---
2160 PRINT #0,"Saving ";na$;"..."
2170 DELETE loadsave$ & na$ & '_dat'
2180 OPEN_NEW #3,loadsave$ & na$ & '_dat'
2190 PRINT #3,na$ : PRINT #3,rm : PRINT #3,lz : PRINT #3,lk : PRINT #3,hp : PRINT #3,ic
2200 FOR x = 7 TO 20 : PRINT #3,lo(x)
2210 CLOSE #3
2220 PRINT #0,"Done!"
2230 GO TO 680
2240 :
2250 IF yi = 0 THEN wd$(1) = a$
2260 RETurn
2270 :
2280 REMark descriptions  de$(..,1), de$(..,2)
2290 DATA "You are in the tavern","A staircase is visible here"
2300 DATA "You are upstairs in the tavern","A small room lies to the east"
2310 DATA "You are in a small room","A dresser is here, beside a bed"
2320 DATA "You are inside the house","A fireplace burns softly nearby"
2330 DATA "You are at the village well","Water rises from depths below"
2340 DATA "You are on a path","A village stands to the north"
2350 DATA "You are in a clearing","A forest grows to the south"
2360 DATA "You are inside a hut","A table is here, beside a bookshelf"
2370 DATA "You are facing an oak tree","It is twisted by age and time"
2380 DATA "You are in the western woods","A cottage is west"
2390 DATA "You are inside the cottage","A bed is here, where you can rest"
2400 DATA "You are in the middle forest","A lake is the to east"
2410 DATA "You are beside the lake","A path heads west into the forest"
2420 DATA "You are at a large hill","It bends south past a small farm"
2430 DATA "You are at the forest edge","The growth is less dense here"
2440 DATA "You are by the castle","A moat stands to the west"
2450 DATA "You are near the castle moat","The drawbridge is down (for now)"
2460 DATA "You are in the main hall","Doors line either side of the hallway"
2470 DATA "You are in guest quarters","It is mostly bare save for a bed"
2480 DATA "You are in the guild","Some tables are beside a fireplace here"
2490 DATA "You are in the parlor","A library is west and the throne north"
2500 DATA "You are at the throne","A scepter is missing from one side"
2510 DATA "You are in the library","Rows of books line tall shelves here"
2520 DATA "You are in the dungeon","It is quite dark in here"
2530 DATA "You are inside a cell","On a table rests some items"
2540 :
2550 REMark verbs vb$()
2560 DATA "go","get","drop","inventory","use","open","examine","climb","kill"
2570 DATA "north","south","east","west","up","down","quit","eat","drink","look","save"
2580 :
2590 REMark nouns 7-20 (1-6=directions) no$()
2600 DATA "lantern","oil","rope","key"
2610 DATA "dagger","chainmail","robe"
2620 DATA "food","water","scepter"
2630 DATA "villager","goblin","knight"
2640 DATA "demon"
2650 :
2660 REMark object descriptions 7-20  ob$()
2670 DATA "a brass lantern","a flask of oil","coiled rope about 10 feet","a small key"
2680 DATA "a fine dagger","a suit of chainmail","an elven robe","some food rations"
2690 DATA "this water makes you thirsty","the jeweled scepter!","a common villager"
2700 DATA "a menacing goblin","a powerful knight","a hideous demon"
2710 :
2720 REMark map info 25 locations  m()
2730 DATA 0,0,0,5,2,0
2740 DATA 0,0,3,0,0,1
2750 DATA 0,0,0,2,0,0
2760 DATA 0,5,0,0,0,0
2770 DATA 4,6,1,0,0,0
2780 DATA 5,7,0,0,0,0
2790 DATA 6,10,0,0,0,0
2800 DATA 0,0,0,0,0,9
2810 DATA 0,12,0,0,0,0
2820 DATA 7,15,12,11,0,0
2830 DATA 0,0,10,0,0,0
2840 DATA 9,14,13,10,0,0
2850 DATA 0,0,0,12,0,0
2860 DATA 12,0,0,0,0,0
2870 DATA 10,0,0,16,0,0
2880 DATA 0,0,15,17,0,0
2890 DATA 18,0,16,0,0,0
2900 DATA 21,17,19,20,0,0
2910 DATA 0,0,0,18,0,0
2920 DATA 0,0,18,0,0,0
2930 DATA 22,18,0,23,0,0
2940 DATA 0,21,0,0,0,0
2950 DATA 0,0,21,0,0,24
2960 DATA 25,0,0,0,23,0
2970 DATA 0,24,0,0,0,0
2980 :
2990 REMark lo() info
3000 DATA 89,89,89,89,89,89
3010 DATA 3,3,11,4,11,20,8,1,5
3020 DATA 25,5,10,17,24
3030 STOP
3040 :
3050 DEFine FuNction Left$(strng$,number)
3060   IF number < 1 THEN
3070     RETurn ""
3080   ELSE
3090     IF number <= LEN(strng$) THEN
3100       RETurn strng$(1 TO number)
3110     ELSE
3120       RETurn strng$ : REMark slice larger than string!
3130     END IF
3140   END IF
3150 END DEFine Left$
3160 :
3170 DEFine FuNction Mid$(strng$,strt,lngth)
3180   IF strt < 1 OR strt > LEN(strng$) THEN
3190     RETurn ""
3200   ELSE
3210     RETurn strng$(strt TO strt+lngth-1)
3220   END IF
3230 END DEFine Mid$
3240 :
3250 DEFine FuNction Right$(strng$,number)
3260   IF number < 1 THEN RETurn ""
3270   IF number > LEN(strng$) THEN RETurn strng$
3280   RETurn strng$(LEN(strng$)-number+1 TO LEN(strng$))
3290 END DEFine Right$
3300 :
3310 DEFine PROCedure Xtv
3320   REMark SBASIC only
3330   OUTLN #0,SCR_XLIM,SCR_YLIM,0,0
3340   WINDOW SCR_XLIM,SCR_YLIM-52,0,0 : WINDOW #2,SCR_XLIM,SCR_YLIM-52,0,0 : WINDOW #0,SCR_XLIM,52,0,SCR_YLIM-52
3350   BORDER #1,1,255 : BORDER #2,1,255 : BORDER #0,1,255
3360   CSIZE #2,0,0 : CSIZE 0,0 : PAPER #2,7 : PAPER 2 : INK #2,2 : INK 7
3370   CLS : CLS #2 : CLS #0
3380 END DEFine Xtv
3390 :
3400 DEFine PROCedure Sa
3410   SAVE win1_8Kadv_8KADVql_bas : QSAVE win1_8Kadv_8KADVql
3420 END DEFine Sa
